#ifndef C_IO_CENTER_FUNC__
#define C_IO_CENTER_FUNC__

#include "DefMsg.h"

/********************************
All functions use in IoCenter
********************************/

//IoCenterFuncs.cpp
void putMsg(const int16_t debugIdx, const char *format, ...);
int initIoQueue();
int ReadIoConfig();
int initTimerIO();
int initTimerFlash();
int initTimerStrobe();
int initTimerRestore();
int initTimerValueCoil();
int initTimerBty();
void initSwitchData();
int sendToTimerCenter(TIME_DELAY_REC *timeDelayRec, short msgID, const void *msg, short size);
int sendToDiskCenter(short msgID, const void *msg, short size);
int inputLED(int portNo, int pinNo, int pinValue);
int ioPinRead();
int ioPinWrite(int pinNo, int pinValue);
int checkPinOutput(int pinNo, int pinValue);
int checkPinInput(int pinNo, int pinValue);
int operateIO(int portNo, unsigned char * input);
int getInputType(int portNo, int pinNo, int pinValue);
int getOutputPin(char devType, char outputType);
int getInputPin(char devType, char inputType);
int ioPinWriteSwitch(char outputType);
int inputSwitch(char switchType, int pinValue, int pinNo, int portNo);
int inputPD(char pdType, int pinValue, int pinNo, int portNo);
int inputMisc(char miscType, int pinValue, int pinNo, int portNo);
int inputSignal(char signalType, int pinValue, int pinNo, int portNo);
int queueHandler(int fd);
//control switch
int throwSwitch(char reqPos);
void addSwStatus(int status);
void removeSwStatus(int status);
int canThrowSwitch();
int checkSwStatus(char reqPos);
//store power/lever and machine fault status
int storeStatus(int flag, int value);
int readStatus(short flag);


//IoCenterTimeFuncs.cpp
int processIOTimerMessage(int code);
int processBtyTimerMessage(int code);
void timerHitPsDeb(COMMON_MSG_DATA * myComMsgRcv);
void timerHitPsInt(COMMON_MSG_DATA * myComMsgRcv);
void timerHitLever(COMMON_MSG_DATA * myComMsgRcv);
void timerHitSwRun(COMMON_MSG_DATA * myComMsgRcv);
void timerHitInDeb(COMMON_MSG_DATA * myComMsgRcv);
void timerHitIndGap();
void timerHitLight();
void timerHitFlash();
void timerHitStrobe();
void timerHitBattery();

//IoCenterSwitchFunc.cpp
void pressureSwGood(COMMON_MSG_DATA * myComMsgRcv);
void pressureSwBad(COMMON_MSG_DATA * myComMsgRcv);
void switchStdNor();
void switchStdRev();
void switchStdTgl();
void switchAuxNor();
void switchAuxRev();
void switchAuxTgl();
void indicationStdNor();
void indicationStdNor1();
void indicationStdRev();
void indicationStdRev1();
void indicationAuxNor();
void indicationAuxNor1();
void indicationAuxRev();
void indicationAuxRev1();
void lockout();
void lockout1();
void occupancy();
void occupancy1();
void powerLever();
void powerLever1();
void onePD();
void onePD1();
void gappedSignal();
void gappedSignal1();
void strobe();
void strobe1();

//IoCenterIOFuncs.cpp
short ProcessIoMsg(COMMON_MSG_DATA * thisComMsg, int thisCode);

#endif
